﻿Type=Activity
Version=3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Dim FolderList As List
	Dim FolderI = 0 As Int
	Dim Folders As List

	Dim ltvFolders As ListView
	Dim lblGetPathComment As Label
	Dim btnGetPathExit As Button

	Dim TopDir = "/" As String
	Dim DefaultDir = "/" As String
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("GetPath")

	lblGetPathComment.Text = Main.PText.Get(10)

End Sub

Sub Activity_Resume
	DevicePaths
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If TopDir.EndsWith("VocabTrainer") Then
		Main.ProgDataPath = TopDir
	Else
		Main.ProgDataPath = TopDir & "VocabTrainer"
	End If
	CallSubDelayed(Main, "InitProg")
End Sub

Sub DevicePaths()
	ltvFolders.SingleLineLayout.ItemHeight = 40dip
	ltvFolders.SingleLineLayout.Label.Height = 40dip
	ltvFolders.SingleLineLayout.Label.TextSize = 20
	
	FolderList.Initialize
	Folders.Initialize

	FolderI = 0
	TopDir = DefaultDir
	FolderList.Add(TopDir)
	Folders.Add(DefaultDir)
	GetFiles(FolderList.Get(FolderI))
End Sub

Sub GetFiles(cDir As String)
	Dim i As Int
	Dim lst0, lst1 As List
	Dim txt As String
	
	lst0.Initialize
	lst0 = File.ListFiles(cDir)
	ltvFolders.Clear
	Folders.Clear
	ltvFolders.AddSingleLine(Chr(8624))
	Folders.Add(Chr(8624))
	lst1.Initialize
	
	If lst0.IsInitialized Then
		If lst0.Size > 0 Then
			For i = 1 To lst0.Size 
				txt = lst0.Get(i - 1)
				If File.IsDirectory(cDir, txt) Then
					ltvFolders.AddSingleLine(txt)
					Folders.Add(txt)
				Else
					lst1.Add(txt)
				End If
			Next
			lst1.Sort(True)
		End If
	End If
End Sub

Sub ltvFolders_ItemClick (Position As Int, Value As Object)
	Log("Click")
	If Position = 0 Then
		If FolderI > 0 Then
			FolderList.RemoveAt(FolderI)
			FolderI = FolderI - 1
			TopDir = FolderList.Get(FolderI)
			GetFiles(TopDir)
		End If
	Else
		TopDir = TopDir & Value & "/"
		FolderI = FolderI + 1
		FolderList.Add(TopDir)
		GetFiles(TopDir)
	End If

	ltvFolders.SetSelection(0)
End Sub

Sub btnGetPathExit_Click
	Activity.Finish
End Sub